% Wolfgang Lemke, April 2008
% Kalman smoother for time-const and timevar. SSM
function [asms,Psms]=WL_Kalmansmo(afis,Pfis,aprs,Pprs,Kapt,istv);

%*******************
%   Dimensions 
%*******************
[Tbig,nsta]=size(afis);

%*******************
%   Provide empty result matrices and multidim arrays 
%*******************
asms=NaN*ones(Tbig,nsta);
Psmsfis=NaN*ones(nsta,nsta,Tbig);

%*******************
%   Prepare for time-variant and time-invariant SSM
%*******************
if istv==0;
% unlike for the filter/pred algorith, here only the tv version:
% if ssm is time-invariant, make a sequence of the Kap matrices
    Kapts=zeros(nsta,nsta,Tbig);
    for tt=1:Tbig;
        Kapts(:,:,tt)=Kapt;
    end;
else;
    Kapts=Kapt;
end;

%*******************
%   Conduct the smoothing, starting from the end
%*******************
asmloc=afis(Tbig,:)';
asms(Tbig,:)=asmloc';
Psmloc=Pfis(:,:,Tbig);
Psms(:,:,Tbig)=Psmloc;
for ii=2:Tbig;
    tt=Tbig-ii+1;
    afiloc=afis(tt,:)';
    aprloc=aprs(tt+1,:)'; % note the timing!
    Pfiloc=Pfis(:,:,tt);
    Pprloc=Pprs(:,:,tt+1); % note the timing!
   if rcond(Pprloc) > 10^-12
       invPprloc=inv(Pprloc);
   else
       invPprloc=pinv(Pprloc);
       %dummy=1;
   end
   Pstarloc=Pfiloc*Kapts(:,:,tt+1)'*invPprloc;
    
    asmloc=afiloc+Pstarloc*(asmloc-aprloc);
    Psmloc=Pfiloc+Pstarloc*(Psmloc-Pprloc)*Pstarloc';
    
    asms(tt,:)=asmloc';
    Psms(:,:,tt)=Psmloc;
end;