%Wolfgang Lemke, June 2009
%function generates group (i.e. cells) of G SSM system matrices required to
%estimate the G equations of a structural tv VAR
function [yt,dt,Zt,Ht,ct,Kapt,Rt,Qt]=WL_TVPVAR_MakeSSMGroup(Xmat,RWstdhatCells,p,cvec,InnovVola);
InnovVola=InnovVola(p+1:end,:);
Tbig=size(Xmat,1)-p;
G=size(Xmat,2);
if G<2;
error('WL: have to have VAR dimension of at least 2');
end;
yt=cell(G,1);
dt=cell(G,1);
Zt=cell(G,1);
Ht=cell(G,1);
ct=cell(G,1);
Kapt=cell(G,1);
Rt=cell(G,1);
Qt=cell(G,1);

XBlock=Xmat(p+1:end,:);
XLagsBlock=[];
for pp=1:p;
    XLagsBlock=[XLagsBlock Xmat(p+1-pp:end-pp,:)];
end;
for gg=1:G;
    dimState=gg-1+p*G;
    if gg==1;
        ZtLoc2dim=XLagsBlock;
    else;
        ZtLoc2dim=[XBlock(:,1:gg-1) XLagsBlock];
    end;
    ytLoc=XBlock(:,gg);
    dtLoc=cvec(gg)*ones(Tbig,1); %sic! cvec is vector of constant intercepts of VAR
    ctLoc=zeros(Tbig,dimState);
    
    HtLoc=NaN(1,1,Tbig);
    KaptLoc=NaN(dimState,dimState,Tbig);
    RtLoc=NaN(dimState,dimState,Tbig);
    QtLoc=NaN(dimState,dimState,Tbig);
    ZtLoc=NaN(1,dimState,Tbig);
    for tt=1:Tbig;
        HtLoc(:,:,tt)=InnovVola(tt,gg)^2;
        KaptLoc(:,:,tt)=eye(dimState);
        RtLoc(:,:,tt)=eye(dimState);
        QtLoc(:,:,tt)=(diag(RWstdhatCells{gg}))^2;
        ZtLoc(:,:,tt)=ZtLoc2dim(tt,:);
    end;
    
    yt{gg}=ytLoc;
    dt{gg}=dtLoc;
    Zt{gg}=ZtLoc;
    Ht{gg}=HtLoc;
    ct{gg}=ctLoc;
    Kapt{gg}=KaptLoc;
    Rt{gg}=RtLoc;
    Qt{gg}=QtLoc;
end;

