% Wolfgang Lemke, 4 Nov 2009
% new as WL_VARIRF but autoregressive matrix enters directly in companion
% form

function IRFs=WL_VARIRFCOMP(KapComp,M,ShockVecs,hormax);
% Model is :
% X_t = Kappa_1 X_{t-1} + ... + Kappa_p X_{t-p} + M u_t, 
% u_t ~ D(0, diag), dim(X_t)=G
% INPUT:
% KapComp, dim G*p x G*p
% M
% ShockVecs: G x K, each vector is a shock
% OUTPUT:
% IRFs: G x K x (hormax+1)
[G,K]=size(ShockVecs);
[Gmalp,Gmalp]=size(KapComp);
p=Gmalp/G;
IRFs=NaN(G,K,hormax+1);
if p==1;
    MComp=M;
elseif p>1; 
    MComp=[M; zeros(G*(p-1),G)];
end;
for hh=0:hormax;
    IRFLoc=KapComp^hh*MComp*ShockVecs;
    IRFLoc=IRFLoc(1:G,1:K);
    IRFs(:,:,hh+1)=IRFLoc;
end;