%************************************
% Wolfgang Lemke, 9. Nov 2007
%************************************
% I checked with eviews from examples:
% parameter estimates are nearly the same, but differ at some higher digits
% residuals are also similar


function [Bcomp,cvec,Dmat,Bpl_ev,VC_eps,infovec]=WL_VARest(Y,vlag,iscon,Exogmat);

cvec=0;
Dmat=0;
infovec=0;

[rowexog,Nofexog]=size(Exogmat);

%************************************
% Make compact data set, cut off missings then
%************************************
[Tbig0,Nbig]=size(Y);
Tbig=Tbig0-vlag;
% ..
allY=zeros(Tbig,(vlag+1)*Nbig);
% fill 'block-column-wise'
uplcc=1; %current upper left block-col cell
for ii=0:vlag;
    allY(:,uplcc:uplcc+Nbig-1)=Y(1+vlag-ii:Tbig0-ii,1:Nbig);
    uplcc=uplcc+Nbig;
end;
allYlag=allY(:,Nbig+1:end);
Y=allY(:,1:Nbig);

Xmat=allYlag;
if iscon==1;
    Xmat=[Xmat ones(Tbig,1)];
    cvec=zeros(Nbig,1);
end;

if rowexog>1; % check if one or more columns of zeros are among the exog variables
    indz=sum(abs(Exogmat(vlag+1:end,:)));
    bindelind=indz==0;
    if mean(bindelind)==1;
        Exogmat=0;
    else;
        allind=1:Nofexog;
        delind=allind(bindelind==1);
        Exogmat(:,delind)=[];
    end;
end;
[rowexog,Nofexog]=size(Exogmat);
if rowexog>1;
    Xmat=[Xmat Exogmat(vlag+1:end,:)];
    Dmat=zeros(Nbig,Nofexog);
else;
    Nofexog=0;
end;

%************************************
% Estimate and construct companion form B matrix, and collect resid series
%************************************
Residmat=zeros(Tbig,Nbig);
Bcompsm=zeros(Nbig,Nbig*vlag);
for ii=1:Nbig;
    yloc=Y(:,ii);
    [beta_loc,tval,resid_loc,Rsq] = WL_ols(yloc,Xmat);
    Bcompsm(ii,:)=beta_loc(1:vlag*Nbig)';
    Residmat(:,ii)=resid_loc;
    if iscon==1;
    cvec(ii)=beta_loc(vlag*Nbig+1);
    end;
    if length(Exogmat)>1;
    Dmat(ii,:)=beta_loc(end-Nofexog+1:end)';
    end;
end;
Bcomp=[Bcompsm; kron(eye(vlag-1),eye(Nbig)) zeros((vlag-1)*Nbig,Nbig)];
VC_eps=cov(Residmat,1); % second argument insures division by the number of rows instead of number of rows minus one
% Correct for estimated parameters:(see Luetkepohl)
VC_eps=VC_eps*Tbig/(Tbig-vlag*Nbig-1-Nofexog);
% note that Tbig is here already the number of observation tuples, i.e
% Tbig0 minus number of lags

%***************************
% compute eviews result matrix for check
%**************************
roBplev=Nbig*vlag;    
Bpl_ev=zeros(roBplev,Nbig);
for jj=1:Nbig;
    colloc=Bcompsm(jj,:)';
    matloc=reshape(colloc,Nbig,vlag);
    colloc=reshape(matloc',vlag*Nbig,1);
    Bpl_ev(:,jj)=colloc;
end;
if iscon==1;
    Bpl_ev=[Bpl_ev; cvec'];
end;
if  length(Exogmat)>1;;
    Bpl_ev=[Bpl_ev; Dmat'];
end;

infovec=Residmat;
