% Wolfgang Lemke, 21 Nov 2010
function [CUSUM,CUSUMBands5,CUSUMBands10]=WL_cusum(resids0,d,Tmax);
% see Harvey, FSMKF, p. 257
resids=resids0(d+1:end);
T=length(resids0);
m1=mean(resids);
sigstar=sqrt(sum((resids-m1).^2)/(T-d-1));
CUSUM=NaN(Tmax,1);
CUSUMBands5=NaN(Tmax,2);
CUSUMBands10=NaN(Tmax,2);
CUSUM(d+1:Tmax)=cumsum(resids0(d+1:Tmax))/sigstar;
for tt=d+1:Tmax;
    cb5=0.948*sqrt(T-d)+2*0.948*(tt-d)/sqrt(T-d);
    cb10=0.850*sqrt(T-d)+2*0.850*(tt-d)/sqrt(T-d);
    CUSUMBands5(tt,:)=[-cb5,cb5];
    CUSUMBands10(tt,:)=[-cb10,cb10];
end;
