function fMatIter = WL_iterFactorReg(yMat,fMat,lamb0,Lamb,isLambtv);

% INPUT:
% yMat: T x N matrix of observations
% fMat: T x G matrix of factors
% lamb0: N x 1 vector (also for the tv version: this is constant)
% if isLambtv==1:
%   Lamb: T x N x G
% if isLambtv==0:
%   Lamb: N x G

% OUTPUT:
% fMatIter: implied factors T x G matrix again

[T,G]=size(fMat);

fMatIter=NaN(T,G);
% now run a series of cross-section regressions
for tt=1:T;
    y=yMat(tt,:)'-lamb0;
    if isLambtv==1;
       X=squeeze(Lamb(tt,:,:));
    else
       X=Lamb;
    end;
    ResOLS=ols(y,X);
    fMatIter(tt,:)=ResOLS.beta';
end;

