function fMatIter = WL_iterFactorRegObs(yMat,fMat,lamb0,Lamb,isLambtv,Obspos);

% INPUT:
% yMat: T x N matrix of observations
% fMat: T x G matrix of factors
% lamb0: N x 1 vector (also for the tv version: this is constant)
% Obspos: 1 x nbobs (nbobs is the nb of observable variables in the VAR, the vector includes the position of the observables in the VAR)
% if isLambtv==1:
%   Lamb: T x N x G
% if isLambtv==0:
%   Lamb: N x G

% OUTPUT:
% fMatIter: implied factors T x G matrix again

[T,G]=size(fMat);

fMatIter=NaN(T,G-length(Obspos));
if isLambtv == 1 %Observable wird herasugerechnet
    tmp = [];
    for tt = 1:T
        tmp(tt,:) = fMat(tt,Obspos)*squeeze(Lamb(tt,:,Obspos));
    end
    yMat=yMat-tmp;        
else
    yMat=yMat-fMat(:,Obspos)*Lamb(:,Obspos)';
end

% now run a series of cross-section regressions
for tt=1:T;
    y=yMat(tt,:)'-lamb0;
    if isLambtv==1;
       X=squeeze(Lamb(tt,:,:));
    else
       X=Lamb;
    end;
    X(:,Obspos) = [];
    ResOLS=ols(y,X);
    fMatIter(tt,:)=ResOLS.beta';
end;
tmp0 = fMat;
tmp = 1:G; 
tmp0(:,tmp(tmp~=Obspos)) = fMatIter;
fMatIter = tmp0; clear tmp0 tmp;
