function fMatIter = WL_iterFactorSSM(yMat,fMat1top,tvlamb0,tvLamb,Rvec,tvKapTildeComp,tvP,tvInnovVola,FiOrSmo);

% INPUT:
% yMat: T x N matrix of observations
% fMat1top: [f1'; f2'], i.e. p x G

% OUTPUT:
% fMatIter: implied factors T x G matrix again

[T,N,G]=size(tvLamb);
p=size(tvKapTildeComp,3)/G;

fMatIter=NaN(T-p,G);
t1=p+1;
T1=T-p;
pG=p*G;

% define the SSM matrices
yt=yMat(t1:end,:);
dt=tvlamb0(t1:end,:);
ct=zeros(T1,pG);
% have to redefine the arrays due to different size formating
Kapt=NaN(pG,pG,T1);
Rt=zeros(pG,G,T1);
Qt=NaN(G,G,T1);
Zt=zeros(N,pG,T1);
Ht=NaN(N,N,T1);
for tt=1:T1;
    Kapt(:,:,tt)=squeeze(tvKapTildeComp(tt+p,:,:));
    Ploc=squeeze(tvP(tt+p,:,:));
    Sloc=diag(tvInnovVola(tt+p,:).^0.5);
    Rt(1:G,:,tt)=inv(Ploc)*Sloc;
    Qt(:,:,tt)=eye(G);
    Zt(:,1:G,tt)=squeeze(tvLamb(tt+p,:,:));
    Ht(:,:,tt)=diag(Rvec.^2);
end;
a0=reshape(flipud(fMat1top)',pG,1);
P0=zeros(pG,pG);
inista=1;
istv=1;
[afis,Pfis,yprs,Fprs,aprs,Pprs,llh]=WL_Kalman(yt,dt,Zt,Ht,ct,Kapt,Rt,Qt,a0,P0,inista,istv);
[asms,Psms]=WL_Kalmansmo(afis,Pfis,aprs,Pprs,Kapt,istv);

if FiOrSmo==1;
    fMatIter=afis(:,1:G);
elseif FiOrSmo==2;
    fMatIter=asms(:,1:G);
end;

fMatIter=[fMat1top; fMatIter];
