function negllh=WL_objfct_tvreg_GARCHvola(auxpars,a0,P0,y,XA,XB);
    % set up state space model
    %@GARCH: note that the GARCH part is taken care of WITHIN the
    %WL_Kalman_GARCHvola function
    pars=auxpars; pars(end-2:end)=auxpars(end-2:end).^2;
    yt=y;
    Xresort=[XA XB];
    [Tbig,cA]=size(XA);
    [Tbig,cB]=size(XB);
    gam=pars(1:cA);
    dt=XA*gam;
    Zt=reshape(XB',1,cB,Tbig); % WL_Kalman requires this to be an array
    
    Ht=zeros(1,1,Tbig); % @GARCH here different
    ct=zeros(Tbig,cB);
    Kapt=NaN(cB,cB,Tbig); %does the construction of Kapt, Rt, Qt go faster?
    Rt=Kapt;
    Qt=Kapt;
    Qmat=(diag(pars(cA+1:cA+cB)))^2;

    %@GARCH: THE GARCH PARAMETERS gamma0, gamma1, gamma2
    k=pars(cA+cB+1:end);
    gam0=k(1); gam1=k(2); gam2=k(3);
    %@GARCH: the additional GARCH parameters
    Hplus=0;
    Gam=1;
           
    for tc=1:Tbig;
        Ht(:,:,tc)=Hplus;
        Kapt(:,:,tc)=eye(cB);
        Rt(:,:,tc)=eye(cB);
        Qt(:,:,tc)=Qmat;
    end;
    inista=1; % use the given a0, P0
    istv=1;
    [afis,Pfis,yprs,Fprs,aprs,Pprs,hseries,eps2stars,llh]=WL_Kalman_GARCH_Meas(yt,dt,Zt,Hplus,ct,Kapt,Rt,Qt,Gam,gam0,gam1,gam2,a0,P0,inista,istv);
    %[afis,Pfis,yprs,Fprs,aprs,Pprs,llh]=WL_Kalman(yt,dt,Zt,Ht,ct,Kapt,Rt,Qt,a0,P0,inista,istv);
    negllh=-llh;
    end %end nested function
