%Wolfgang Lemke, 8 July 2010
function [pointIRF,meanIRF,quantilesIRF,info]=WL_tvFFAVAR_IRFwtBands_KappaRestr(VAREStates,VARVarStates,LoadEStates,LoadVarStates,ShockVec,p,t,n,M,myquantiles,Hor,cumul,KappaTVInd);

% FUNCTION VERSION FOR SOME ELEMENTS OF KAPPA BEING FIXED,
% ONLY FOR THE SPECIAL CASE OF P=1
% NEW INPUT:
% KappaTVInd: Matrix of zeros and ones indicating which positions of Kappa
% are fixed (0!!!) or tv (1)
% in our example:
% KappaTVInd=ones(10,10); KappaTVInd(1:4,5:10)=0;


G=length(ShockVec);
Horpl1=Hor+1;
nbquant=length(myquantiles);
allIRFs=NaN(M,Horpl1);

% pointIRF: (Horpl1,1);
% meanIRF: (Horpl1,1);
% quantilesIRF: (Horpl1,nbquant);

% note the dimension of the states from the VAR,eg
% asmosRestr : Gx1 cell, PsmosRestr: Gx1 cell
% first a-cell entry is (T-p) x (p*G)
% first P-cell entry is (p*G) x (p*G) x (T-p)
% Gth a-cell entry is (T-p) x (G-1 + p*G)
% Gth P-cell entry is (G-1 + p*G) x (G-1 + p*G) x (T-p)

% for the selected point t in time:
% put the means and variance matrices of the G equations into cell objects
VAREStateCell=cell(G,1);
VARVarStateCell=cell(G,1);
for gg=1:G;
    VAREStateCell{gg}=(VAREStates{gg}(t-p,:))';
    VARVarStateCell{gg}=squeeze(VARVarStates{gg}(:,:,t-p));
end;

% mean and variance for the draw of the loadings:
ELoad=squeeze(LoadEStates(t,n,:));
VarLoad=squeeze(LoadVarStates(t,n,:,:));
cholVarLoad=chol(VarLoad);

% create the corresponding VAR objects for the point IRF
[P, KapArray, KapTildeArray, KapTildeComp]=WL_TVPVAR_StateGroup2SVAR(VAREStateCell);
% IRs of factors
ATilde=inv(P);
FacIRF=WL_VARIRFCOMP(KapTildeComp,ATilde,ShockVec,Hor); % size G x 1 x Horpl1
FacIRF=squeeze(FacIRF); % squeeze out middle element since here only one shock vector
% draw from the respective loading
pointIRF=FacIRF'*ELoad; 
if cumul==1;
    pointIRF=100*cumsum(pointIRF);
end;

% container for the drawn states at 
VARDrawStateCell=cell(G,1);

mm=0; %counter of successfull draws
Mall=0; %counter of number of all draws
while mm<M;
    Mall=Mall+1;
    % draw the states corresponding to the G Var equations (i.e to P and
    % Kap)
    for gg=1:G;
        mu=VAREStateCell{gg};
        V=VARVarStateCell{gg};
        % find out which states relate to fixed parameters
        nbStates=length(mu);
        activeBin=ones(1,nbStates);
        activeBin(gg:end)=KappaTVInd(gg,:);
        activeInd=1:nbStates;
        activeInd=(activeInd(activeBin>0))';
        VPart=V(activeInd,activeInd);
        aVARDrawPart=mu(activeInd)+chol(VPart)'*randn(sum(activeBin),1);   
        aVARDraw=mu;
        aVARDraw(activeInd)=aVARDrawPart;
        VARDrawStateCell{gg}=aVARDraw;
    end;
    % create the corresponding VAR objects
    [P, KapArray, KapTildeArray, KapTildeComp]=WL_TVPVAR_StateGroup2SVAR(VARDrawStateCell);
    if max(abs(eig(KapTildeComp)))<1; %check for nonexplosiveness
        mm=mm+1;
        % generate the IRs of factors 
        ATilde=inv(P);
        FacIRFDraw=WL_VARIRFCOMP(KapTildeComp,ATilde,ShockVec,Hor); % size G x 1 x Horpl1
        FacIRFDraw=squeeze(FacIRFDraw); % squeeze out middle element since here only one shock vector
        % draw from the respective loading
        LoadDraw=ELoad+cholVarLoad'*randn(G,1);
        IRFDraw=LoadDraw'*FacIRFDraw; % this is  a row vector
        if cumul==1;
            IRFDraw=100*cumsum(IRFDraw);
        end;
        allIRFs(mm,:)=IRFDraw;
    end;
end;
meanIRF=mean(allIRFs)';
quantilesIRF=quantile(allIRFs,myquantiles)';
info.Mall=Mall;
    
    
    
    
    
    