function [MM,WW,Ystand] = transfstandard(Y); %variance = 1, mean = 0, WW: standard deviations (for IRFs)

%input
    %Y: TxN matrix of data
%outputs
    %Ystand: Y with mean 0 and var 1
    %WW: matrix of standard deviations
    
[T,N] = size(Y);

Y0 = Y; 
Y1 = [];
Ystand = [];
for i=1:N 
    Y1(:,i) = Y(:,i)-mean(Y(:,i)');
    Ystand(:,i) = (Y(:,i)-mean(Y(:,i)))/std(Y(:,i));   
end    
WW = diag(std(Y0)); 
MM = mean(Y0);
    
