function [MM,WW,Ystand] = transfstandard_MeanAdj(Y)

%variance = 1, mean = 0, WW: standard deviations (for IRFs)

%input
    %Y: TxN matrix of data
%outputs
    %Ystand: Y with mean 0 and var 1
    %WW: matrix of standard deviations
    
[T,N] = size(Y);

Y0 = Y; 
Y1 = Y;
Ystand = Y;

for i=1:N 
    % Adjust Pre-Lehman data
    Y1(1:end-16,i) = Y(1:end-16,i)-mean(Y(1:end-16,i)');
    Ystand(1:end-16,i) = (Y(1:end-16,i)-mean(Y(1:end-16,i)))/std(Y(:,i));   
    % Adjust Post-Lehman data
    Y1(end-16+1:end,i) = Y(end-16+1:end,i)-mean(Y(end-16+1:end,i)');
    Ystand(end-16+1:end,i) = (Y(end-16+1:end,i)-mean(Y(end-16+1:end,i)))/std(Y(:,i));   
end    
WW = diag(std(Y0)); 
MM = mean(Y0);
    
