function [Ystat] = transfstat(Y,code); %transformation to get stationarity

%inputs
    %Y: TxN matrix of data
    %code: 1xN says how data are transformed
%output
    %Ystat: stationary data
    
[T,N] = size(Y);

%Transformations
Ystat = Y(3:end,:);
for i = 1:N
    if code(:,i) == 1, %lv
    elseif code(:,i) == 2, %delta lv
        Ystat(:,i) = Y(3:end,i)-Y(2:end-1,i);
    elseif code(:,i) == 4, %ln
        Ystat(:,i) = log(Ystat(:,i));
    elseif code(:,i) == 5, %delta ln
        Ystat(:,i) = log(Y(3:end,i))-log(Y(2:end-1,i));
    elseif code(:,i) == 6, %delta2 ln
        tmp = log(Y(2:end,i))-log(Y(1:end-1,i));
        Ystat(:,i) = tmp(2:end,:)-tmp(1:end-1,:); clear tmp;
    end
end    